// Copyright (C) 2008 Andy R Terrel
// Licensed under the GNU LGPL Version 3.0 or later.

#include "Fluid.h"

using namespace dolfin;

//-----------------------------------------------------------------------------
Fluid::Fluid (Mesh &mesh) :
  _mesh(mesh), _vel_subdomains(0), _vel_bc_funcs(0)
{ }

//-----------------------------------------------------------------------------
Fluid::Fluid (Mesh& mesh,MeshFunction<uint>& vel_subdomains,
	      Array< Function* >& vel_bc_funcs) :
  _mesh(mesh), _vel_subdomains(&vel_subdomains)
{ 
  for (uint i = 0; i < vel_bc_funcs.size(); i++)
    _vel_bc_funcs.push_back(vel_bc_funcs[i]);
}

//-----------------------------------------------------------------------------
void Fluid::toFile (std::string base_filename, bool print_pressure)
{
  std::string velocity_filename = base_filename + "_velocity.pvd";
  File velocity_writer(velocity_filename.c_str());
  velocity_writer << _velocity;
  if (print_pressure) {
    std::string pressure_filename = base_filename + "_pressure.pvd";
    File pressure_writer(pressure_filename.c_str());
    pressure_writer << _pressure;    
  }
}

//-----------------------------------------------------------------------------
// end of file
